<!--- 
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the pt_forum directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2010.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files 
in this directory, you agree to the terms and conditions of the applicable 
end user license agreement.
--->

<!---
/* ***************************************************************
/*
Author: 
	PaperThin Inc.
	G. Cronkright		
Name:		
	forum_topics_listing_default_rh.cfm
Element:
	Forum Topics
History:
	2009-10-27 - GAC - Created
	2009-12-09 - MFC - Modified
	2009-03-21 - GAC - Modified
--->
<cfscript>
	// As the Default renderhandler for the Forum Categories process even if the element is empty
	request.element.hasData = 1;

	// leave isStatic=0 so not to cache specific users data
	request.element.isStatic = 0; 
	
	// Get the Configuration data
	appConfigStruct = application.ptForum.getAppConfig();
	
	// Set the UI theme from the Configuration Element
	if ( LEN(appConfigStruct['forum_ui_theme']) )
		UItheme = appConfigStruct['forum_ui_theme'];
	else 
		UItheme = 'redmond';
	
	// load jQuery headers
	application.ptForum.scripts.loadJQuery("1.3.2");
	// load headers for jQuery thick box
	application.ptForum.scripts.loadADFLightbox();
	// load header for jQuery UI
	application.ptForum.scripts.loadJQueryUI("1.7.2", UItheme);
	
	// Get Page URLS
	topicsPageURL = Application.ptForum.forumsService.getTopicsURL();
	threadsPageURL = Application.ptForum.forumsService.getThreadsURL();
	messagesPageURL = Application.ptForum.forumsService.getMessagesURL();

	// Get Custom Element Data (should be filtered by Category/CatID)
	items = attributes.elementInfo.elementData.propertyValues;
	
	// Check that we have items
	if ( ArrayLen(items) )
		commCatID = items[1].Values.catid;
	else
	{
		// Else, no items so far, check the Category Data
		catData = application.ADF.cedata.getCEData("Forum Categories", "catID", request.params.catid);
		// check if we have data
		if ( ArrayLen(catData) ){
			commCatID = catData[1].Values.catID;
		}
		else {
			commCatID = "";	
		}
	}
	
	// get HomeURL no matter what is passed in (if nothing is passed defaults to: index.cfm) 
	homeURL = Application.ptForum.forumsService.getHomeURL("catid", commCatID);
	
	// Get the Category data set
	parentStruct = Application.ptForum.categoriesDAO.getCategoryInfoByCatID(TRIM(commCatID));
	request.ptForum.category = parentStruct.values;
	
	// Setup the vars for the parent info
	ParentID = "";
	ParentName = "";
	ParentDescription = "";
	ParentCreatedDateTime = "";

	// Check if the parent struct is defined
	if ( IsDefined("parentStruct") AND structKeyExists(parentStruct,"values") ) {
		if ( structKeyExists(parentStruct.values,"CatID") ) 
			ParentID = parentStruct.values.CatID;
		if ( structKeyExists(parentStruct.values,"CatName") ) 
			ParentName = parentStruct.values.CatName;
	}
	
	// initialize a record counter for displayed items 
	itemCount = 0;
	
	// Set the page security
	pageSecurity = Application.ptForum.SecurityService.getPageSecurity("CatID", ParentID);
	//application.ADF.utils.dodump(pageSecurity, "pageSecurity", false);

	// Get Forum Home URL ParentID = CatID
	cat_home_url = Application.ptForum.forumsService.getHomeURL("CatID", ParentID);
</cfscript>

<!--- TODO: don't forget to re-enable read Security --->
<cfif pageSecurity.canReadPage IS false>
	<cfif FindNoCase("?",cat_home_url)>
		<cfset cat_home_url = cat_home_url & "&error=norights" />
	<cfelse>
		<cfset cat_home_url = cat_home_url & "?error=norights" />
	</cfif>
	<cflocation url="#cat_home_url#" addtoken="false">
</cfif>

<cfscript>
	// LightBox Options
	AddRecordLinkText = "New Topic";
		
	AjaxPath = application.ADF.ajaxProxy;
	AjaxBean = "topicsForms";
	renderForm = "renderAddEditForm";
	
	formID = application.ptForum.getForumTopicsFormID();
	dpid = 0;
	formResultHTML = "";
	
	lightboxwidth = 500;
	lightboxheight = 300;
</cfscript>

<!--- <cfoutput><h2 class="forumTitle">Forum</h1><br /></cfoutput> --->

<!--- // include the breadcrumbs --->
<cfinclude template="/ADF/apps/pt_forum/customcf/inc_forums_crumbs.cfm">
<!--- // To modify BreadCrumbs file move to the site and use this path  --->
<!--- <cfinclude template="#request.subsitecache[1].url#_cs_apps/pt_forum/customcf/inc_forums_crumbs.cfm"> --->

<!--- // Do not display button if not loggedin --->
<cfif request.user.id GT 0 AND pageSecurity.canPostPage IS true>
	<cfoutput>
	<script type="text/javascript">
		jQuery(function() {
			// Hover states on the static widgets
			jQuery("div.ui_button").hover(
				function() { 
					$(this).css("cursor", "hand");
					$(this).addClass('ui-state-hover');
				},
				function() { 
					$(this).css("cursor", "pointer");
					$(this).removeClass('ui-state-hover');
				}
			);
		});
	</script>
	<style>
		div.ui_button {
			width: 140px;
			text-align: center;
			padding: 4px 0 4px 0;
		}
	</style>
	<div id="addNew" style="padding:20px 20px 20px 0px;">
		<!--- // Open Form in Lightbox using renderAddEditForm --->
		<div id="newPostLink" rel="#AjaxPath#?method=#renderForm#&bean=#AjaxBean#&formid=#formID#&datapageid=#dpid#&lbAction=refreshparent&customizedFinalHTML=#URLEncodedFormat(formResultHTML)#&catid=#commCatID#&width=#lightboxwidth#&height=#lightboxheight#" title="#AddRecordLinkText#" class="ADFLightbox ui_button ui-state-default ui-corner-all">#AddRecordLinkText#</div> 
	</div>
	</cfoutput>		
</cfif>


<cfoutput>
<!-- Content Start -->
<div class="forum_content_box">
	
	<cfif LEN(TRIM(ParentName))>
	<div class="row_title">
		<p>Category: #ParentName#</p>
	</div>
	</cfif>
	
	<div class="row_name">
		<div class="left_20 keep_on border_right"><p>Topic</p></div>
		<div class="left_40 keep_on border_right"><p>Description</p></div>
		<div class="left_10 keep_on border_right"><p>Messages</p></div>
		<div class="left_auto keep_on"><p>Last Post</p></div>
	</div>
	
	<cfif ArrayLen(items)>
		<cfloop from="1" to="#ArrayLen(items)#" index="i">
			<!--- Get the security for the current item --->
			<cfset itemSecurity = Application.ptForum.SecurityService.getItemSecurity("TopicID", items[i].values.topicid)>
			<!--- <cfdump var="#itemSecurity#" label="itemSecurity" expand="false"> --->
			
			<cfif itemSecurity.canReadItem IS true>
				<cfset itemCount = itemCount + 1 />
				<div class="row_#(itemCount mod 2)#">
					<div class="left_20 keep_on border_right"><p><a href="#threadsPageURL#?topicid=#items[i].values.topicid#">#items[i].values.topicName#</a></p></div>
					<div class="left_40 keep_on border_right"><p>#items[i].values.topicDescription#</p></div>
					<div class="left_10 keep_on border_right"><p>#items[i].values.messageQty#</p></div>
					<div class="left_auto keep_on">
						<p>
							<cfif LEN(TRIM(items[i].values.lastpostMsgID))>
								#Application.ptForum.messagesService.getLastPostLinkFormatedString(items[i].values.lastpostMsgID,items[i].values.lastpostProfileID,items[i].values.lastPostDateTime)#
							</cfif>
						</p>
					</div>
				</div>
			</cfif>
		</cfloop>
	</cfif>	
	
	<!--- // Show Error Message if NO records are available --->
	<cfif ArrayLen(items) EQ 0 OR itemCount EQ 0>
		<div class="row_0">Sorry, but there are no topics available for this category.</div>						
	</cfif>
</div>
</cfoutput>

